BasicScrollBarUI.TrackListener (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf.basic, class: BasicScrollBarUI, class: TrackListener
Keywords: javax.swing.plaf.basic.BasicScrollBarUI.TrackListener class

# Class BasicScrollBarUI.TrackListener

java.lang.Object
java.awt.event.MouseAdapter
javax.swing.plaf.basic.BasicScrollBarUI.TrackListener

All Implemented Interfaces:
  `MouseListener, MouseMotionListener, MouseWheelListener, EventListener`

Enclosing class:
  `BasicScrollBarUI`

protected class BasicScrollBarUI.TrackListener extends MouseAdapter implements MouseMotionListener
Track mouse drags.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected int`
  `currentMouseX`
  Current mouse x position
  `protected int`
  `currentMouseY`
  Current mouse y position
  `protected int`
  `offset`
  The offset

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TrackListener()`
  Constructs a `TrackListener`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `mouseDragged(MouseEvent e)`
  Set the models value to the position of the thumb's top of Vertical scrollbar, or the left/right of Horizontal scrollbar in left-to-right/right-to-left scrollbar relative to the origin of the track.
  `void`
  `mouseExited(MouseEvent e)`
  Invoked when the mouse exits the scrollbar.
  `void`
  `mousePressed(MouseEvent e)`
  If the mouse is pressed above the "thumb" component then reduce the scrollbars value by one page ("page up"), otherwise increase it by one page.

  ### Methods declared in class MouseAdapter

  `mouseClicked, mouseEntered, mouseMoved, mouseReleased, mouseWheelMoved`
  Modifier and Type
  Method
  Description
  `void`
  `mouseClicked(MouseEvent e)`
  Invoked when the mouse button has been clicked (pressed and released) on a component.
  `void`
  `mouseEntered(MouseEvent e)`
  Invoked when the mouse enters a component.
  `void`
  `mouseMoved(MouseEvent e)`
  Invoked when the mouse cursor has been moved onto a component but no buttons have been pushed.
  `void`
  `mouseReleased(MouseEvent e)`
  Invoked when a mouse button has been released on a component.
  `void`
  `mouseWheelMoved(MouseWheelEvent e)`
  Invoked when the mouse wheel is rotated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### offset

    protected transient int offset
    The offset

  - ### currentMouseX

    protected transient int currentMouseX
    Current mouse x position

  - ### currentMouseY

    protected transient int currentMouseY
    Current mouse y position

- ## Constructor Details

  - ### TrackListener

    protected TrackListener()
    Constructs a `TrackListener`.

- ## Method Details

  - ### mousePressed

    public void mousePressed(MouseEvent e)
    If the mouse is pressed above the "thumb" component then reduce the scrollbars value by one page ("page up"), otherwise increase it by one page. If there is no thumb then page up if the mouse is in the upper half of the track.
    Specified by:
      `mousePressed` in interface `MouseListener`
    Parameters:
      `e` - the event to be processed

  - ### mouseDragged

    public void mouseDragged(MouseEvent e)
    Set the models value to the position of the thumb's top of Vertical scrollbar, or the left/right of Horizontal scrollbar in left-to-right/right-to-left scrollbar relative to the origin of the track.
    Specified by:
      `mouseDragged` in interface `MouseMotionListener`
    Overrides:
      `mouseDragged` in class `MouseAdapter`
    Parameters:
      `e` - the event to be processed

  - ### mouseExited

    public void mouseExited(MouseEvent e)
    Invoked when the mouse exits the scrollbar.
    Specified by:
      `mouseExited` in interface `MouseListener`
    Parameters:
      `e` - MouseEvent further describing the event
    Since:
      1.5